@echo off
:: Define the path for a separate log file for the batch process
set "batLogFile=%~dp0ScheduleRebootBatchLog.txt"

:: Function to write to the batch log file
echo. >> "%batLogFile%"
echo --- Starting Task Scheduling --- >> "%batLogFile%"
echo %date% %time% >> "%batLogFile%"

:: Check for Administrator permissions
net session >nul 2>&1
if %errorLevel% NEQ 0 (
    echo Requesting Administrator privileges...
    PowerShell -Command "Start-Process cmd -ArgumentList '/c ""%~f0""' -Verb RunAs"
    exit /B
)

set "ScriptPath=%~dp0ScheduleReboot.ps1"
echo Starting PowerShell script to schedule the reboot...
echo %date% %time% - Starting PowerShell script to schedule the reboot... >> "%batLogFile%"

:: Run the PowerShell script directly with elevated permissions and proper execution policy
PowerShell.exe -ExecutionPolicy Bypass -NoProfile -File "%ScriptPath%" >> "%batLogFile%" 2>&1

:: Wait for PowerShell to finish
echo Waiting for task creation verification...
timeout /t 5 >nul

:: Check if the task exists using schtasks
schtasks /Query /TN "Scheduled Reboot Event - Black Screen fix - 3C Technology" >nul 2>&1
if %errorlevel%==0 (
    echo Task "Scheduled Reboot Event - Black Screen fix - 3C Technology" created successfully.
    echo %date% %time% - Task created successfully. >> "%batLogFile%"
) else (
    echo Task creation failed or the task does not exist.
    echo %date% %time% - Task creation failed or the task does not exist. >> "%batLogFile%"
)

:: Add a pause to keep the command prompt window open
pause
